#pragma once

#include <QOpenGLWidget>
#include <QOpenGLFunctions>
#include <QOpenGLBuffer>
#include <QOPenGLVertexArrayObject>
#include <QOpenGlShaderProgram>

class OpenGlViewer : public QOpenGLWidget, protected QOpenGLFunctions
{
	Q_OBJECT

public:
	OpenGlViewer(QWidget *parent);
	~OpenGlViewer();

private:
	QOpenGLBuffer mVertexBuffer;
	QOpenGLVertexArrayObject mVertexArray;
	QOpenGLShaderProgram* mProgram = nullptr;

private:
	void printContextInformation();

protected:
	virtual void initializeGL() override final;
	virtual void resizeGL(int w, int h) override final;
	virtual void paintGL() override final;

public:
};
